import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;

public class MyArrayList<T> {
    protected T[] array;

    public MyArrayList() {

    }

    public MyArrayList(T[] array)
    {
        this.array = array;
    }

    public T[] add(T newElement) {
        //T[] newArray = (T[]) Array.newInstance(array.getClass().getComponentType(), 6);(Nhu)
        //T[] resultObjectArray = (T[])new Object[array.length+1];(Error when returning)
        //T[] resultObjectArray=new Object[array.length+1];
        T[] resultObjectArray = Arrays.copyOf(this.array, this.array.length + 1);
        resultObjectArray[array.length] = newElement;
        return resultObjectArray;
    }

    public T[] addIndex(T newElement, int index) {
        int m = 0;
        T[] resultObjectArray = (T[]) Array.newInstance(array.getClass().getComponentType(), array.length + 1);
        for (int i = 0; i < array.length + 1; i++) {
            if (i < index) {
                resultObjectArray[m] = array[i];

            }
            if (i == index) {
                resultObjectArray[m] = newElement;

            }
            if (i > index) {
                resultObjectArray[m] = array[i - 1];
            }
            m++;
        }
        return resultObjectArray;
    }

    public T get(Integer index) {
        T element = null;
        for (int i = 0; i < array.length; i++) {
            if (i == index) {
                element = array[i];
            }
        }
        return element;
    }

    public T[] remove(Integer indexToRemove) {
        T[] resultObjectArray = Arrays.copyOf(this.array, this.array.length - 1);
        int m = 0;
        for (int i = 0; i < array.length; i++) {
            if (i != (indexToRemove)) {
                resultObjectArray[m] = array[i];
                m++;
            }
        }
        return resultObjectArray;
    }

    public T[] clear() {
        T[] resultObjectArray = (T[]) Array.newInstance(array.getClass().getComponentType(), 0);
        return resultObjectArray;
    }

    public T[] set(T element, Integer position) {
        T[] resultObjectArray = Arrays.copyOf(this.array, this.array.length);

        for (int i = 0; i < array.length; i++) {
            if (i == position) {
                resultObjectArray[i] = element;

            } else {
                resultObjectArray[i] = array[i];

            }

        }
        return resultObjectArray;
    }
    public boolean isEmpty()
    {
        boolean result=false;
        if(array.length==0)
        {
            result=true;
        }
        else
        {
            result=false;
        }
        return result;
    }
    public boolean contains(T element)
    {
        boolean result=false;
        for(int i=0;i<array.length;i++)
        {
            if(array[i]==element)
            {
                result=true;
            }
        }
        return result;
    }
}
