import org.junit.Assert;
import org.junit.Test;

import java.lang.reflect.Array;
import java.util.Arrays;

public class Myset<T> {
    protected T[] array;
    public Myset()
    {

    }
    public Myset(T[] array)
    {

        this.array = array;
    }
    public T[] add(T newElement)
    {
        T[] resultObjectArray;
        MyArrayList myArrayList=new MyArrayList(array);

        if(myArrayList.contains(newElement)==true)
        {
            resultObjectArray = Arrays.copyOf(this.array, this.array.length);
        }
        else
            {
            resultObjectArray = Arrays.copyOf(this.array,this.array.length + 1);

            for (int i = 0; i < array.length; i++) {
                resultObjectArray[i] = array[i];
            }
            resultObjectArray[array.length] = newElement;

        }
        return resultObjectArray;
    }


    public T[] clear() {
        T[] resultObjectArray = (T[]) Array.newInstance(array.getClass().getComponentType(), 0);
        return resultObjectArray;
    }

    public Boolean contains(T element) {
        boolean result=false;
        for(int i=0;i<array.length;i++)
        {
            if(array[i]==element)
            {
                result=true;
            }
        }
        return result;
    }

    public Boolean isEmpty() {
        boolean result=false;
        if(array.length==0)
        {
            result=true;
        }
        else
        {
            result=false;
        }
        return result;
    }
}
